//
//  Gestion des interruptions 
//    INT0 : signal RX gaz
//
//  www.thyzoon.fr
//  2015
//

#include "Arduino.h"


// Entrée PIN 2 
#define Rx_pin 2 

//**************************************
// Fontion de capture impulsion RX sous interruption
// La resolution est d'environ : 
//  4µs avec un ATMEGA328p à 16MHz
//  8µs avec un ATMEGA328p à 8MHz

void Capture_Rx() {
  extern boolean flag_pulse_rx; 
  extern word tpulse; // defini par ailleurs en "volatile"

  static unsigned long temps;  // temps courant (depuis mise sous tension)
  static unsigned long t0;     // temps mémorisé au front montant
  
  temps = micros();          // temps courant en µs
    
  // Detection du front montant = interrupt + niveau '1'  
  if (digitalRead(Rx_pin) == HIGH) {
    t0 = temps;  
  }
  // sinon front descendant
  else {
    tpulse = (word) (temps - t0); // calcul pulse Rx Gaz
    flag_pulse_rx = true;
  } 
}

//***************************************
// Gestion de l'entrée sous interrruption
void Init_rx() {
  // Interruption 0
  // Broche 2
  pinMode(Rx_pin, INPUT);
  // prise en compte INT sur front montant et descendant
  attachInterrupt(0, Capture_Rx , CHANGE); 
}  
